Unit Menu;

Interface

 Type RowColor = record
       Main:Byte;
       Text:Byte;
       First:Byte;
      End;

 Type WindowColor = record
       Frame:Word;
       InFrame:Byte;
       Main:Byte;
       SelRow:Byte;
      End;

 Type Row = record
       Text:String[78];
       First:Shortint; { ak je -1 potom sa neda selektnut  }
                       { ak je -3 tak je poslednym riadkom }
                       { ak je  0 tak riadok nema hotkey   }
       Col:RowColor;
      End;

 Type RowArray = Array[1..20] of Row;

 Type Window = object
       X,Y,X1,Y1:Integer;
       Col:WindowColor;
       BackImg:Pointer;
       Visible:Boolean;
       BackWin:Boolean;
       F:File;
       ScrPath:String;

       Destructor DeInit;
       Procedure Show;
       Procedure Hide;
       Function IsVisible:Boolean;
       Procedure Move(DeltaX,DeltaY:Integer);
       Constructor Init(IX,IY,IX1,IY1:Integer;ICol:WindowColor;IBW : Boolean;screenpath:String);
      End;

 Type SelectWindow = object(Window)
       Rows:RowArray;
       LastRow:Byte;
       MaxLength:Byte;
       SelectRow:Shortint;
       Sip:Boolean;

       Constructor Init(IX,IY:Integer;ICol:WindowColor;ISip:Boolean;IBW:Boolean;screenpath:String);
       Function Select(SelRow:Shortint):Shortint;
       Procedure InitRow(INumRow:Shortint;IText:String;ICol:RowColor);
   {--------UnDocumented---------}
       Procedure DrawRow(NumRow:Byte);
      End;

 Type FileName = String[12];

 Type FileWindow = object(Window)
       Files:Array[1..99] of FileName;
       RowCol:RowColor;


       Constructor Init(IX,IY:Integer;ICol:WindowColor;RCol:RowColor;IBW:Boolean;screenpath:String);
       Function Select(Name:FileName;Attr:Byte):FileName;
   {--------UnDocumented---------}
       Procedure DrawRow(NumRow,DrawFile:Byte);
      End;

 Type InputWindow = object(Window)
       RowCol:RowColor;
       Leng:Byte;
       Txt:String;

       Constructor Init(IX,IY:Integer;ICol:WindowColor;RCol:RowColor;IBW:Boolean;IText:String;ILength:Byte;screenpath:String);
       Function Input:String;
      End;

Implementation

 Uses KeyBoard,Graph,Crt,Dos,Mouse;
 VAr s:String;
{*******************************************************}
 Procedure Window.Hide;
  Begin
   If Visible Then
    Begin
     HideMouse;
     If BackWin Then
      Begin
     GetMem(BackImg,ImageSize(x,y,x1,y1));
     assign(f,scrpath);
     Reset(f,1);
     blockread(f,backimg^,ImageSize(x,y,x1,y1));
     close(f);
     PutImage(x,y,BackImg^,NormalPut);
     FreeMem(BackImg,ImageSize(x,y,x1,y1));
     End;
     Visible:=False;
     ShowMouse;
    End;
  End;
{*******************************************************}
 Function Window.IsVisible:Boolean;
  Begin
   IsVisible:=Visible;
  End;
{*******************************************************}
 Destructor Window.DeInit;
  Begin
   Hide;
   x:=0;
   y:=0;
   x1:=0;
   y1:=0;
  End;
{*******************************************************}
 Constructor Window.Init(IX,IY,IX1,IY1:Integer;ICol:WindowColor;IBW : Boolean;screenpath:String);
  Var a,MaxLen:Byte;
  Begin
   scrpath:=screenpath;
   x:=ix;
   y:=iy;
   x1:=ix1;
   y1:=iy1;
   Col:=ICol;
   BackWin := IBW;
   HideMouse;
   ShowMouse;
   Visible:=False;
  End;
{*******************************************************}
 Procedure Window.Show;
 Var a:Byte;
     b:pointer;
  Begin
   HideMouse;
   If Visible=False Then
    Begin
   If BackWin then
    begin
     GetMem(BackImg,ImageSize(x,y,x1,y1));
     GetImage(x,y,x1,y1,backImg^);
     assign(f,scrpath);
     Rewrite(f,1);
     blockwrite(f,backimg^,ImageSize(x,y,x1,y1));
     close(f);
     FreeMem(BackImg,ImageSize(x,y,x1,y1));
    End;
   SetFillStyle(1,Col.Main);
   Bar(x,y,x1,y1);
   SetLineStyle(0,0,1);
   SetColor(Col.InFrame);
   RecTangle(x+1,y+1,x1-1,y1-1);
   RecTangle(x+2,y+2,x1-2,y1-2);
   RecTangle(x+3,y+3,x1-3,y1-3);
   MoveTo(x,y1);
   SetColor(Lo(Col.Frame));
   LineTo(x,y);
   LineTo(x1,y);
   SetColor(Hi(Col.Frame));
   LineTo(x1,y1);
   LineTo(x,y1);
   MoveTo(x+4,y1-4);
   SetColor(Hi(Col.Frame));
   LineTo(x+4,y+4);
   LineTo(x1-4,y+4);
   SetColor(Lo(Col.Frame));
   LineTo(x1-4,y1-4);
   LineTo(x+4,y1-4);
   Visible:=True;
   End;
   ShowMouse;
  End;
{*******************************************************}
 Procedure Window.Move(DeltaX,DeltaY:Integer);
  Begin
   If BackWin then
    Begin
     Hide;
     X:=X+DeltaX;
     Y:=Y+DeltaY;
     X1:=X1+DeltaX;
     Y1:=Y1+DeltaY;
     Show;
    End;
  End;
{*******************************************************}
 Procedure SelectWindow.InitRow(INumRow:Shortint;IText:String;ICol:RowColor);
  Begin
   Rows[INumRow].Col:=ICol;
   Rows[INumRow].First:=0;
   Rows[INumRow].First:=Pos('~',IText);
   If Pos('~',IText)=Length(IText) Then
    Begin
     Rows[INumRow].First:=-1;
     Delete(IText,Length(IText),1);
    End
   Else
    Delete(IText,Rows[INumRow].First,1);
   If Length(IText)=0 Then Rows[INumRow].First:=-3;
   Rows[INumRow].Text:=IText;
  End;
{*******************************************************}
 Constructor SelectWindow.Init(IX,IY:Integer;ICol:WindowColor;ISip:Boolean;IBW : boolean;screenpath:String);
  Var a,MaxLen:Byte;
  Begin
   scrpath:=screenpath;
   Sip:=ISip;
   x:=ix;
   y:=iy;
   BackWin := IBW;
   Col:=ICol;
   LastRow:=15;
    For a:=1 to 15 do
     If Rows[a].First=-3 Then
      Begin
       LastRow:=Pred(a);
       a:=15;
      End;
   MaxLength:=0;
    For a:=1 to LastRow do
     Begin
      MaxLen:=Length(Rows[a].Text);
      If Maxlen>MaxLength Then MaxLength:=MaxLen;
     End;
   x1:=x+MaxLength*8+16;
   y1:=y+LastRow*10+16;   { zavisi od fontu }
   HideMouse;
   ShowMouse;
   Visible:=False;
  End;
{*******************************************************}
 Procedure SelectWindow.DrawRow(NumRow:Byte);
  Begin
   HideMouse;
   SetFillStyle(1,Rows[NumRow].Col.Main);
   Bar(x+8,y+10*NumRow,x1-8,y+10*Succ(NumRow)-2);
   SetColor(Rows[NumRow].Col.Text);
   OutTextXY(x+9,y+10*NumRow+1,Rows[NumRow].Text);
   SetColor(Rows[NumRow].Col.First);
   If (Rows[NumRow].First>0)And(Rows[NumRow].First<=Length(Rows[NumRow].Text)) Then
    OutTextXY(x+1+8*Rows[NumRow].First,y+10*NumRow+1,
      Rows[NumRow].Text[Rows[NumRow].First]);
   ShowMouse;
  End;
{*******************************************************}
 Function SelectWindow.Select(SelRow:Shortint):Shortint;
 Var Povel:Word;
     a:Integer;
     SelRowArray:Array[1..21] of Byte;
     EndRow:Byte;
     But:Byte;
     ViewPort:ViewPortType;

  Begin
   Show;
   For a:=1 to LastRow do
    DrawRow(a);
   FillChar(SelRowArray,21,0);
   EndRow:=1;
   For a:=1 to LastRow do
    If Rows[a].First>-1 Then
     Begin
      SelRowArray[EndRow]:=a;
      If a=SelRow Then SelRow:=EndRow;
      Inc(EndRow);
     End;
    If SelRow>=EndRow Then SelRow:=1;
    If EndRow=1 Then Exit;
    GetViewSettings(ViewPort);
   Repeat
    a:=Rows[SelRowArray[SelRow]].Col.Main;
    Rows[SelRowArray[SelRow]].Col.Main:=Col.SelRow;
    DrawRow(SelRowArray[SelRow]);
    Povel:=CitajKlavOrButton;
    Rows[SelRowArray[SelRow]].Col.Main:=a;
    DrawRow(SelRowArray[SelRow]);
    Case Povel of
     SipH:Begin
           Dec(SelRow);
           If SelRow=0 Then SelRow:=EndRow-1;
          End;
     SipD:Begin
           Inc(SelRow);
           If SelRow=EndRow Then SelRow:=1;
          End;
     PgUp,HomeKey:SelRow:=1;
     PgDn,EndKey:SelRow:=EndRow-1;
     Esc:Begin
          Select:=-1;
          Hide;
          Exit;
         End;
     LeftButton:Begin
                 If ClickInWindow(x+8,y+10,x1-8,y1-10,LeftButton) Then
                  Begin
                   If Rows[(GetMouseY-y) div 10].First>-1 Then
                    If SelRow=(GetMouseY-y) div 10 Then Povel:=13;
                    SelRow:=(GetMouseY-y) div 10;
                  End;
                End;
    End;
    If ClickInWindow(x-2,y-2,x+4,y+4,LeftButton)=True Then
     Begin
      Select:=-1;
      Hide;
      Exit;
     End;
    If (Sip)And((Povel=SipP)Or(Povel=SipL)) Then
     Begin
      If Povel=SipL Then Select:=-2;
      If Povel=SipP Then Select:=-3;
      Exit;
     End;
    If (Povel<255)And(Povel>4) Then
     For a:=1 to EndRow-1 do
     With Rows[SelRowArray[a]] do
      Begin
       If(First>0) Then
        If UpCase(Chr(Povel))=UpCase(Text[First]) Then
         Begin
          Select:=SelRowArray[a];
          Exit;
         End;
      End;
   Until Povel=13;
   Select:=SelRowArray[SelRow];
   ShowMouse;
  End;
{*******************************************************}
 Procedure FileWindow.DrawRow(NumRow,DrawFile:Byte);
  Begin
   HideMouse;
   SetFillStyle(1,RowCol.Main);
   Bar(x+8,y+10*DrawFile,x1-8,y+(10*(DrawFile+1))-2);
   SetColor(RowCol.Text);
   OutTextXY(x+9,y+10*DrawFile+1,Files[NumRow]);
   ShowMouse;
  End;

 Constructor FileWindow.Init(IX,IY:Integer;ICol:WindowColor;RCol:RowColor;IBW:Boolean;screenpath:String);
  Begin
   scrpath:=screenpath;
   BackWin:=IBW;
   x:=ix;
   y:=iy;
   x1:=x+12*8+16;
   y1:=y+10*10+20;
   Col:=ICol;
   RowCol:=RCol;
   HideMouse;
   ShowMouse;
   Visible:=False;
  End;

 Function FileWindow.Select(Name:FileName;Attr:Byte):FileName;
  Var
   Povel:Word;
   a:Integer;
   SelFile,FirstFile,NumFiles:Byte;
   Dir:String;
   SFile:SearchRec;
   Zmena:Boolean;
  Begin
   Window.Show;
   Povel:=255;
   GetDir(0,Dir);
   FillChar(Files,SizeOf(Files),0);
   a:=1;
   FindFirst(Dir+'\'+Name,Attr,SFile);
   Files[a]:=SFile.Name;
   While (DosError=0)Or(a=100) do
    Begin
     Inc(a);
     FindNext(SFile);
     Files[a]:=SFile.Name;
    End;
   Files[a]:='';
   NumFiles:=a-1;
   FirstFile:=1;
   SelFile:=1;
   If NumFiles=0 Then
    Begin
     Files[1]:='no files';
     DrawRow(1,1);
     Povel:=CitajKlavOrButton;
     Select:='';
     Hide;
     Exit;
    End;
   Zmena:=True;
   Repeat
    If Zmena=True Then
     For a:=FirstFile to FirstFile+9 do
      DrawRow(a,a-FirstFile+1);
     a:=RowCol.Main;
     RowCol.Main:=Col.SelRow;
     DrawRow(SelFile+FirstFile-1,SelFile);
     RowCol.Main:=a;
    Povel:=CitajKlavOrButton;
    Zmena:=False;
     If (Povel=SipH)Or(ClickInWindow(x+6,y-2,x1-6,y+4,LeftButton)) Then
      Begin
       Delay(10);
       DrawRow(SelFile+FirstFile-1,SelFile);
       If (SelFile=1)And(FirstFile>1) Then
        Begin
         SelFile:=1;
         Dec(FirstFile);
         Zmena:=True;
        End;
       If SelFile>1 Then Dec(SelFile);
      End;
     If (((Povel=SipD)Or(ClickInWindow(x+6,y1-5,x1-6,y1+2,LeftButton)))And(FirstFile+SelFile-1<NumFiles)) Then
      Begin
       Delay(10);
       DrawRow(SelFile+FirstFile-1,SelFile);
       If (SelFile+FirstFile-1>=FirstFile+9) Then
        Begin
         Inc(FirstFile);
         Zmena:=True;
        End
        Else Inc(SelFile);
      End;
     If Povel=HomeKey Then
      Begin
       SelFile:=1;
       FirstFile:=1;
       Zmena:=True;
      End;
     If Povel=EndKey Then
      Begin
       If NumFiles>10 Then SelFile:=10
       Else SelFile:=NumFiles;
       If NumFiles>10 Then FirstFile:=NumFiles-9;
       Zmena:=True;
      End;
     If Povel=Esc Then
      Begin
       Select:='';
       Hide;
       Exit;
      End;
     If ClickInWindow(x-2,y-2,x+4,y+4,LeftButton)=True Then
      Begin
       Select:='';
       Hide;
       Exit;
      End;
      If (NumFiles>10)And(ClickInWindow(x+8,y+10,x1-8,y1-10,LeftButton)) Then
       Begin
	SelFile:=((GetMouseY-y) div 10);
	Povel:=13;
       End;
      If ClickInWindow(x+8,y+10,x1-8,y1-10{-(10*(10-NumFiles))},LeftButton) Then
       Begin
	SelFile:=((GetMouseY-y) div 10);
	Povel:=13;
       End;
   Until Povel=13;
   Select:=Files[SelFile+FirstFile-1];
   Hide;
  End;

 Constructor InputWindow.Init(IX,IY:Integer;ICol:WindowColor;RCol:RowColor;IBW:Boolean;IText:String;ILength:Byte
              ;screenpath:String);
  Begin
   scrpath:=screenpath;
   BackWin:=IBW;
   x:=ix;
   y:=iy;
   x1:=x+(Length(IText)+ILength)*8+16;
   y1:=y+30;
   Col:=ICol;
   RowCol:=RCol;
   Leng:=ILength;
   Txt:=IText;
   HideMouse;
   ShowMouse;
   Visible:=False;
  End;

 Function InputWindow.Input:String;
 Var Povel:Word;
     a:Byte;
     InpStr,HelpStr:String;
 Procedure Cursor(Miesto:Byte);
  Begin
   HideMouse;
   SetColor(RowCol.First);
     If Miesto+1<=Leng Then
      Begin
       SetColor(RowCol.Main);
       OutTextXY(x+10+Length(Txt)*8+(Miesto+1)*8-8,y+13,'_');
       SetColor(RowCol.First);
       OutTextXY(x+10+Length(Txt)*8+(Miesto+1)*8-8,y+12,InpStr[Miesto+1]);
      End;
     If Miesto-1>0 Then
      Begin
       SetColor(RowCol.Main);
       OutTextXY(x+10+Length(Txt)*8+(Miesto-1)*8-8,y+13,'_');
       SetColor(RowCol.First);
       OutTextXY(x+10+Length(Txt)*8+(Miesto-1)*8-8,y+12,InpStr[Miesto-1]);
      End;
   SetColor(RowCol.Text);
   OutTextXY(x+10-8+Length(Txt)*8+Miesto*8,y+13,'_');
   ShowMouse;
  End;
  Begin
   FillChar(InpStr,255,0);
   FillChar(HelpStr,255,0);
   Show;
    SetColor(RowCol.Text);
    HideMouse;
    OutTextXY(x+10,y+12,Txt);
    ShowMouse;
    SetColor(RowCol.First);
    a:=1;
    Repeat
     Cursor(a);
     Povel:=CitajKlavOrButton;
     If (Povel>31)And(Povel<127) Then
      Begin
       SetColor(RowCol.Main);
       HideMouse;
       OutTextXY(x+10+Length(Txt)*8,y+12,InpStr);
       Insert(Char(Povel),InpStr,a);
       Delete(InpStr,Leng+1,1);
       SetColor(RowCol.First);
       OutTextXY(x+10+Length(Txt)*8,y+12,InpStr);
       ShowMouse;
       If a<Leng Then Inc(a);
      End;
     If ClickInWindow(x-2,y-2,x+4,y+4,LeftButton)=True Then
      Begin
       Input:='';
       Hide;
       Exit;
      End;
     Case Povel of
      SipP:If a<Leng Then
       Begin
        If InpStr[a]=#0 Then InpStr[a]:=#32;
        Inc(a);
       End;
      SipL:If a>1 Then Dec(a);
      BackSpace:If a>1 Then
                 Begin
                  HideMouse;
                  SetColor(RowCol.Main);
                  OutTextXY(x+10+Length(Txt)*8,y+12,InpStr);
                  Delete(InpStr,a-1,1);
                  SetColor(RowCol.First);
                  OutTextXY(x+10+Length(Txt)*8,y+12,InpStr);
                  Dec(a);
                  ShowMouse;
                 End;
      Del:Begin
           HideMouse;
           SetColor(RowCol.Main);
           OutTextXY(x+10+Length(Txt)*8,y+12,InpStr);
           Delete(InpStr,a,1);
           SetColor(RowCol.First);
           OutTextXY(x+10+Length(Txt)*8,y+12,InpStr);
           ShowMouse;
          End;
      27:Begin
          Input:='';
          Hide;
          Exit;
         End;
     End;
     HelpStr:=InpStr;
     FillChar(InpStr,255,0);
     InpStr:=HelpStr;
    Until Povel=13;
    Input:=InpStr;
   Hide;
  End;
BEGIN

END.
