Unit Mouse;

Interface

 Function MouseVisible:Boolean;
 Function InstallMouse:Boolean;
 Procedure ShowMouse;
 Procedure HideMouse;
 Function GetMouseX:Integer;
 Function GetMouseY:Integer;
 Function RealGetMouseButton:Word;
 Function NoMouseButton:Word;
 Procedure MoveMouse(x,y:Integer);
 Procedure SetMouseHorizontalRange(x1,x2:Integer);
 Procedure SetMouseVerticalRange(y1,y2:Integer);
 Procedure SetMouseArea(x1,y1,x2,y2:Integer);
 Function GetMouseMotion:Word;
 Procedure LightMouse;
 Procedure NormalMouse;
 Procedure SetMouseDisplayPage(Page:Byte);
 Function GetMouseActivePage:Byte;
 Procedure SetMouseSpeed(XSpeed,YSpeed:Byte);
 Function ClickInWindow(x1,y1,x2,y2:Integer;Button:Byte):Boolean;
 Function MouseInWindow(x1,y1,x2,y2:Integer):Boolean;

 Var GetMouseButton : Function : Word;

Implementation

Uses Dos,Graph;
Var R:Registers;
    MVisible:Boolean;

Function MouseVisible:Boolean;
 Begin
  MouseVisible:=MVisible;
 End;
Procedure ShowMouse;
 Begin
  If MVisible=False Then
   Begin
    r.ax:=$01;
    Intr($33,r);
    MVisible:=True;
   End;
 End;
Procedure HideMouse;
 Begin
  If MVisible=True Then
   Begin
    r.ax:=$02;
    Intr($33,r);
    MVisible:=False;
   End;
 End;

Function RealGetMouseButton:Word;
 Begin
  r.ax:=$03;
  Intr($33,r);
  RealGetMouseButton:=r.bx;
 End;

Function NoMouseButton:Word;
 Begin
  NoMouseButton:=0;
 End;

Function InstallMouse:Boolean;
 Begin
  r.ax:=$00;
  Intr($33,r);
  If r.ax=$0000 Then
   Begin
    InstallMouse:=False;
    GetMouseButton := NoMouseButton;
   End
  Else
   Begin
    InstallMouse:=True;
    GetMouseButton:=RealGetMouseButton;
   End;
  MVisible:=False;
 End;

Function GetMouseX:Integer;
Var ViewPort:ViewPortType;
 Begin
  GetViewSettings(ViewPort);
  r.ax:=$03;
  Intr($33,r);
  GetMouseX:=r.cx-ViewPort.x1;
 End;
Function GetMouseY:Integer;
Var ViewPort:ViewPortType;
 Begin
  GetViewSettings(ViewPort);
  r.ax:=$03;
  Intr($33,r);
  GetMouseY:=r.dx-ViewPort.y1;
 End;
Procedure MoveMouse(x,y:Integer);
 Begin
  r.ax:=$04;
  r.cx:=x;
  r.dx:=y;
  Intr($33,r);
 End;
Procedure SetMouseHorizontalRange(x1,x2:Integer);
 Begin
  r.ax:=$07;
  r.cx:=x1;
  r.dx:=x2;
  Intr($33,r);
 End;
Procedure SetMouseVerticalRange(y1,y2:Integer);
 Begin
  r.ax:=$08;
  r.cx:=y1;
  r.dx:=y2;
  Intr($33,r);
 End;
Procedure SetMouseArea(x1,y1,x2,y2:Integer);
 Begin
  r.ax:=$10;
  r.cx:=x1;
  r.dx:=y1;
  r.si:=x2;
  r.di:=y2;
  Intr($33,r);
 End;
Function GetMouseMotion:Word;
 Begin
  r.ax:=$0b;
  Intr($33,r);
  GetMouseMotion:=r.cx*256+r.dx;
 End;
Procedure LightMouse;
 Begin
  r.ax:=$0d;
  Intr($33,r);
 End;
Procedure NormalMouse;
 Begin
  r.ax:=$0e;
  Intr($33,r);
 End;
Procedure SetMouseDisplayPage(Page:Byte);
 Begin
  r.ax:=$1d;
  r.bx:=Page;
  Intr($33,r);
 End;
Function GetMouseActivePage:Byte;
 Begin
  r.ax:=$1e;
  Intr($33,r);
  GetMouseActivePage:=r.bx;
 End;
Procedure SetMouseSpeed(XSpeed,YSpeed:Byte);
 Begin
  r.ax:=$0f;
  r.cx:=XSpeed;
  r.dx:=YSpeed;
  Intr($33,r);
 End;
Function ClickInWindow(x1,y1,x2,y2:Integer;Button:Byte):Boolean;
 Begin
  ClickInWindow:=False;
  If Button=GetMouseButton Then
   If (GetMouseX>x1)And(GetMouseX<x2)And
      (GetMouseY>y1)And(GetMouseY<y2) Then
    ClickInWindow:=True;
 End;
Function MouseInWindow(x1,y1,x2,y2:Integer):Boolean;
 Begin
  If (GetMouseX>x1)And(GetMouseX<x2)And
     (GetMouseY>y1)And(GetMouseY<y2) Then
      MouseInWindow:=True
  Else MouseInWindow:=False;
 End;
Begin
GetMouseButton:=NoMouseButton;
End.

