unit KorUnit;

interface

uses Graph, Crt;

type PKor=^Kor;
     Kor=object
           constructor Init(x,y,u:real);
           destructor Done; virtual;
           procedure Dopredu(d:real); virtual;
           procedure Vpravo(u:real); virtual;
           procedure Vlavo(u:real); virtual;
           procedure ZmenSmer(u:real); virtual;
           procedure ZmenXY(x,y:real); virtual;
           procedure PresunXY(x,y:real); virtual;
           procedure Ukaz; virtual;
           procedure Skry; virtual;
           procedure PH; virtual;
           procedure PD; virtual;
           procedure ZmenFP(nfp:integer); virtual;
           procedure ZmenHP(nhp:integer); virtual;

           function  XSur:real; virtual;
           function  YSur:real; virtual;
           function  Smer:real; virtual;
           function  Dole:boolean; virtual;
           function  Ukazana:boolean; virtual;
           function  FP:byte; virtual;
           function  HP:byte; virtual;

           procedure ZmenTvar(var obrys); virtual;
           procedure ZmenFarbuTvaru(f:integer); virtual;

           procedure Pis(s:string); virtual;
           function  Smerom(x,y:real):real; virtual;
           procedure Vypln(fv:byte); virtual;
           function  Vzd(x,y:real):real; virtual;
           function  Blizko(x,y:real):boolean; virtual;
         private
           XSur0,YSur0,Smer0:real;
           Dole0,Ukazana0:boolean;
           FP0,HP0: byte;
           fobrys,nobrys:integer;
           pobrys:pointer;
           procedure Ukaz0;
         end;

var Klaves:integer;
    krokuj:boolean;

procedure test;
procedure Zmaz1;
procedure CakajKlaves;
procedure Cakaj(n:integer);

{==========================================================================}

var X0,Y0:integer;     { stred obrazovky = suradnice (0,0) }

const rad=pi/180;

type tObrys=record f:byte; n:integer; pole:array[1..8] of real end;

const troj0:tObrys =
       (f:10; n:8; pole:(90,8,-105,30.9,-150,30.9,-105,8));

      troj1:tObrys =
       (f:15; n:8; pole:(120,11.5,-135,38.6,-150,38.6,-135,11.5));

implementation


{==========================================================================}

procedure CakajKlaves;
begin
  Klaves:=ord(readkey); if Klaves=0 then Klaves:=-ord(readkey);
  if Klaves=27 then begin CloseGraph; halt end;
end;

procedure test;
var b:boolean;
begin
  b:=krokuj;
  while keypressed or b do
    begin
      CakajKlaves;
      if Klaves=19 then b:=not b else b:=false;     {Ctrl/S}
    end
end;

constructor Kor.Init(x,y,u:real);
begin
  XSur0:=x; YSur0:=y; Smer0:=u;
  FP0:=7; HP0:=NormWidth;
  Dole0:=true; Ukazana0:=false;
  ZmenTvar(troj0);
end;

destructor Kor.Done;
begin
  Skry;
  if pobrys<>nil then freemem(pobrys,6*nobrys+3);
  pobrys:=nil;
end;

procedure Kor.Dopredu(d:real);
begin
  ZmenXY(XSur0+sin(Smer0*rad)*d,YSur0+cos(Smer0*rad)*d);
end;

procedure Kor.Vpravo(u:real);
begin
  ZmenSmer(Smer0+u);
end;

procedure Kor.Vlavo(u:real);
begin
  ZmenSmer(Smer0-u);
end;

procedure Kor.ZmenSmer(u:real);
begin
  ukaz0;
  Smer0:=u;
  while Smer0<0 do Smer0:=Smer0+360;
  while Smer0>=360 do Smer0:=Smer0-360;
  ukaz0;
  test;
end;

procedure Kor.ZmenXY(x,y:real);
begin
  if not Dole0 then PresunXY(x,y)
  else
    begin
      ukaz0;
      MoveTo(trunc(XSur0)+X0,Y0-trunc(YSur0));
      SetColor(FP0); SetLineStyle(SolidLn,0,HP0);
      XSur0:=x; YSur0:=y;
      LineTo(trunc(XSur0)+X0,Y0-trunc(YSur0));
      ukaz0;
      test
    end
end;

procedure Kor.PresunXY(x,y:real);
begin
  ukaz0;
  XSur0:=x; YSur0:=y;
  MoveTo(trunc(XSur0)+X0,Y0-trunc(YSur0));
  ukaz0;
  test
end;

procedure Kor.PH;
begin
  Dole0:=false; test
end;

procedure Kor.PD;
begin
  Dole0:=true; test
end;

procedure Kor.Ukaz;
begin
  if not Ukazana0 then
    begin Ukazana0:=true; ukaz0 end;
  test
end;

procedure Kor.Skry;
begin
  if Ukazana0 then
    begin ukaz0; Ukazana0:=false end;
  test
end;

procedure Kor.ZmenFP(nfp:integer);
begin
  FP0:=abs(nfp) mod 16;
  test;
end;

procedure Kor.ZmenHP(nhp:integer);
begin
  if nhp>1 then HP0:=ThickWidth else HP0:=NormWidth;
  test;
end;

function Kor.XSur:real;
begin
  XSur:=Xsur0
end;

function Kor.YSur:real;
begin
  YSur:=Ysur0
end;

function Kor.Smer:real;
begin
  Smer:=Smer0
end;

function Kor.Dole:boolean;
begin
  Dole:=Dole0
end;

function Kor.Ukazana:boolean;
begin
  Ukazana:=Ukazana0
end;

function Kor.FP:byte;
begin
  FP:=FP0
end;

function Kor.HP:byte;
begin
  HP:=HP0
end;

procedure Kor.Vypln(fv:byte);
begin
  ukaz0;
  SetFillStyle(1,abs(fv) mod 16);
  FloodFill(trunc(XSur0)+X0,Y0-trunc(YSur0),FP0);
  ukaz0;
  test
end;

function Kor.Smerom(x,y:real):real;
var u:real;
begin
  x:=x-XSur0; y:=y-YSur0;
  if y=0 then
    if x=0 then u:=0
    else if x<0 then u:=270 else u:=90
  else if y>0 then
    if x>=0 then u:=arctan(x/y)*180/pi
    else u:=360-arctan(-x/y)*180/pi
  else
    if x>=0 then u:=180-arctan(-x/y)*180/pi
    else u:=180+arctan(x/y)*180/pi;
  Smerom:=u
end;

function Kor.Vzd(x,y:real):real;
begin
  Vzd:=sqrt(sqr(x-XSur0)+sqr(y-YSur0));
end;

function Kor.Blizko(x,y:real):boolean;
begin
  Blizko:=Ukazana0 and (sqr(x-XSur0)+sqr(y-YSur0)<100);
end;

procedure Kor.Pis(s:string);
begin
  ukaz0;
  SetColor(FP0);
  OutTextXY(trunc(XSur0)+X0,Y0-trunc(YSur0),s);
  ukaz0;
  test
end;

procedure Kor.ZmenTvar(var obrys);
var t:record f:byte; n:integer; pole:array[1..1] of real end
        absolute obrys;
begin
  Ukaz0;
  if pobrys<>nil then freemem(pobrys,6*nobrys+3);
  with t do
    begin
      fobrys:=f mod 16; nobrys:=n;
      if nobrys=0 then pobrys:=nil
      else
        begin
          getmem(pobrys,6*nobrys+3);
          move(pole,pobrys^,6*nobrys)
        end
    end;
  Ukaz0;
end;

procedure Kor.ZmenFarbuTvaru(f:integer);
begin
  Ukaz0;
  fobrys:=f mod 16;
  Ukaz0;
end;

procedure Kor.Ukaz0;
var i:integer;
    x1,y1,s1:real;
    p:^real;
begin
  if not Ukazana0 then exit;
  if pobrys=nil then exit;
  MoveTo(trunc(XSur0)+X0,Y0-trunc(YSur0));
  SetWriteMode(XORPut);
  SetColor(fobrys); SetLineStyle(SolidLn,0,NormWidth);
  x1:=XSur0; y1:=YSur0; s1:=Smer0; p:=pobrys;
  for i:=1 to nobrys do
    begin
      if odd(i) then s1:=s1+p^
      else if p^<>0 then
        begin
          x1:=x1+sin(s1*rad)*p^; y1:=y1+cos(s1*rad)*p^;
          LineTo(trunc(x1)+X0,Y0-trunc(y1));
        end;
      inc(p);
    end;
  SetWriteMode(NormalPut);
end;

procedure Zmaz1;    {pred Zmaz1 treba Skryt vsetky korytnacky}
begin
  ClearViewPort;
  test;
end;

procedure Cakaj(n:integer);
const cas=100;
var i:integer;
begin
  i:=cas;
  repeat
    test; dec(i); if i<1 then begin dec(n); i:=cas end;
  until n<=0
end;

{======= inicializacia ====================================================}

var gd,gm:integer;
begin
  gd:=Detect; InitGraph(gd,gm,'');
  if GraphResult<>0 then
    begin writeln('Problem s grafickym driverom'); halt; end;
  X0:=GetMaxX div 2+1; Y0:=GetMaxY div 2+1;
  Klaves:=0; krokuj:=false;
end.