unit clocks;
{$X+}  {allow discardable function results}

{ Clock-on-a-menubar OOP extension to Turbo Vision apps

  Copyright (c) 1990 by Danny Thorpe

  Alarms have not been implemented.
}

interface
uses dos, objects, drivers, views, menus, dialogs, app, msgbox;

const  cmClockChangeDisplay = 1001;

       ClockNoSecs   = 0;
       ClockDispSecs = 1;
       Clock12hour   = 0;
       Clock24hour   = 1;
       ClockSlovakia = 0;
       ClockEngland  = 1;

type
     ClockDataRec = record
       Country: word;
       Format: word;
       Seconds: word;
       RefreshStr: String[2];
     end;


     PClockMenu = ^TClockMenu;
     TClockMenu = object(TMenuBar)
       ClockOptions: ClockDataRec;
       Refresh: byte;
       LastTime: DateTime;
       TimeStr: string[10];
       constructor Init (var Bounds: TRect; Amenu: PMenu);
       procedure Draw;   virtual;
       procedure Update; virtual;
       procedure SetRefresh (Secs: integer);        virtual;
       procedure SetRefreshStr (Secs: string);     virtual;
       procedure ClockChangeDisplay;               virtual;
       procedure HandleEvent (var Event: TEvent);  virtual;
       function  FormatTimeStr (h,m,s:word):string; virtual;
     end;




implementation


function LeadingZero(w : Word) : String;
var
  s : String;
begin
  Str(w:0,s);
  if Length(s) = 1 then
    s := '0' + s;
  LeadingZero := s;
end;



constructor TClockMenu.Init(var Bounds: TRect; AMenu: PMenu);
var
 Temp: PMenuBar;
 ClockMenu: PMenu;
 R: TRect;
begin
  ClockMenu:= NewMenu(
                NewSubMenu('~'#0'~Clock ', hcNoContext, NewMenu(
                NewItem('~M~onosti','Alt+Spc',kbAltSpace,cmClockChangeDisplay, hcNoContext,
                nil)),
                AMenu^.Items));
                { ^^ tack passed menubar on end of new clock menu }
  ClockMenu^.Default:= AMenu^.Default;

  TMenuBar.Init(Bounds, ClockMenu);

  fillchar(LastTime,sizeof(LastTime),#$FF);   {fill with 65000's}
  TimeStr:='';
  ClockOptions.Format := Clock24Hour;
  ClockOptions.Seconds := ClockDispSecs;
  ClockOptions.Country := ClockSlovakia;
  SetRefresh(1);
end;



procedure TClockMenu.Draw;
  var P: PMenuItem;
  begin
  P:= FindItem(#0);
  if P <> nil then
    begin
    DisposeStr(P^.Name);
    P^.Name:= NewStr('~'#0'~'+TimeStr);
    end;
  TMenuBar.Draw;
  end;



procedure TClockMenu.Update;
  var h,m,s,hund: word;
  begin
    GetTime(h,m,s,hund);
    if abs(s-LastTime.sec) >= Refresh then
      begin
      with LastTime do
        begin
        Hour:=h;
        Min:=m;
        Sec:=s;
        end;
      TimeStr:= FormatTimeStr(h,m,s);
      DrawView;
      end;
  end;




procedure TClockMenu.SetRefresh(Secs: integer);
  begin
  if Secs > 59 then
    Secs := 59;
  if Secs < 1 then
    Secs := 1;
  Refresh:= Secs;
  Str(Refresh:2,ClockOptions.RefreshStr);
  end;



procedure TClockMenu.SetRefreshStr( Secs: string);
var
  temp,code: integer;
begin
  val(Secs, temp, code);
  if code = 0 then SetRefresh(temp)
  else SetRefresh(1);
end;




procedure TClockMenu.ClockChangeDisplay;

  var
    D: PDialog;
    Control: PView;
    Command: word;
    temp,code: integer;
    R: TRect;
    ClockData : ClockDataRec;

  begin

  ClockData := ClockOptions;

  R.Assign(0,0,40,11);
  D:= new(PDialog, Init(R, 'Hodiny'));
  D^.Flags := D^.Flags xor wfClose;
  D^.Options := D^.Options or ofCenterX or ofCenterY;


  R.Assign(3,3,18,5);
  Control:= new(PRadioButtons, Init(R,
            NewSItem('S~l~ovensk',
            NewSItem('~A~nglick',
            nil))));
  D^.Insert(Control);

  R.Assign(2,2,18,3);
  Control:= new(Plabel, Init(R, '~T~yp', Control));
  D^.Insert(Control);

  R.Assign(20,3,37,5);
  Control:= new(PRadioButtons, Init(R,
            NewSItem('~1~2 hodinov',
            NewSItem('~2~4 hodinov',
            nil))));
  D^.Insert(Control);

  R.Assign(19,2,37,3);
  Control:= new(Plabel, Init(R, '~F~ormt', Control));
  D^.Insert(Control);

  R.Assign(3,6,18,7);
  Control:= new(PCheckBoxes, Init(R,
            NewSItem('~S~ekundy',
            nil)));
  D^.Insert(Control);

  R.Assign(33,6,37,7);
  Control:= new(PInputLine, Init(R, 2));
  D^.Insert(Control);

  R.Assign(19,6,32,7);
  Control:= new(PLabel, Init(R, '~O~bnova 1-59:', Control));
  D^.Insert(Control);
{
  R.Assign(21,7,41,8);
  Control:= new(PLabel, Init(R, 'seknd', PLabel(Control)^.Link));
  D^.Insert(Control);
}
  R.Assign(9,8,19,10);
  Control:= new(PButton, Init(R, 'OK', cmOk, bfDefault));
  D^.Insert(Control);

  R.Assign(19,8,29,10);
  Control:= new(PButton, Init(R, 'Storno', cmCancel, bfNormal));
  D^.Insert(Control);


  D^.SelectNext(False);
  D^.SetData(ClockData);

  Command:= Desktop^.ExecView(D);

  if Command = cmOk then begin
    D^.GetData(ClockData);
{    if ClockData.Seconds = ClockNoSecs then ClockData.RefreshStr := '--';}
    ClockOptions:= ClockData;
    SetRefreshStr(ClockData.RefreshStr);
  end;

  Dispose(D, Done);

  { update display to reflect changes immediately }
  TimeStr:= FormatTimeStr(LastTime.hour, LastTime.min, LastTime.sec);
  DrawView;
end;





procedure TClockMenu.HandleEvent( var Event: TEvent);
  begin
  TMenuBar.HandleEvent( Event);
  if Event.What = evCommand then
    begin
    case Event.Command of
      cmClockChangeDisplay: ClockChangeDisplay;
      end;
    end;
  end;




function TClockMenu.FormatTimeStr(h,m,s: word): string;
var
  st, tail: string;
begin
  tail:='';
  if ClockOptions.Format = Clock24Hour then
    st:= LeadingZero(h)
  else begin
    if h >= 12 then begin
      if ClockOptions.Country = ClockEngland then tail:= 'pm';
      if h>12 then dec(h,12);
    end
    else if ClockOptions.Country = ClockEngland then tail:= 'am';
    if h=0 then h:=12;   {12 am}
    str(h:0,st);    { no leading space on hours }
  end;

  st:=st+':'+ LeadingZero(m);


  if ClockOptions.Seconds = ClockDispSecs then
    st:= st+':'+LeadingZero(s);

  FormatTimeStr:= st + tail;
end;

end.

