unit vesa;{Copyright 1996 Lubomir Dekan}

{POZNAMKA: Prefix 66h je pouzity pre rozsirenie na 32-bitove instrukcie}

interface
const VESAxres=640;VESAyres=480;
var VESAgranul:word;
    VESAinfo:array[0..255] of word;{VesaInfo}

{Zistenie, ci je pritomna VESA}
{Volanie: if check_vesa then OK else EXIT !!!}
function VESAcheck:boolean;

{Vykreslenie pixelu na suradnice x,y s farbou color}
procedure VESAputpixel(x,y:word; color:byte);

{Zistenie farby pixelu na pozicii x,y}
function  VESAgetpixel(x,y:longint):word;

{Inicializacia grafickeho modu}
procedure VESAinit;

{Inicializacia textoveho modu 03h}
procedure textinit;

{Vykresli vodorovnu ciaru na poziciu x,y so sirkou s a adresou [segm:offs]}
procedure VESAdrawline(x,y:longint; s,segm,offs:word);

implementation

function VESAcheck:boolean;
var errcode:byte;
begin
   asm
      mov cx,101h{BX}
      mov ax,ds
      mov es,ax
      mov di,offset VESAinfo
      mov ax,4f01h
      int 10h
      mov errcode,ah
      mov ax,word ptr VESAinfo+4
      mov VESAgranul,ax
    end;

    write('VESAgranul::before=',VESAgranul);
if errcode=0 then VESAgranul:=64 div VESAgranul;
    writeln('::after=',VESAgranul);
    readln;
if errcode=0 then VESAcheck:=true
	     else VESAcheck:=false;
end;

procedure VESAinit;assembler;
asm
   mov ax,4f02h
   mov bx,101h
   int 10h
end;

procedure textinit;assembler;
asm
   mov ax,3
   int 10h
end;

procedure VESAputpixel(x,y:word; color:byte);
var pom:word;
    F:text;
begin

if (x<VESAxres)and(y<VESAyres) then
 begin
{ Bank:   test    cs:VesaMode,0ffh
        jz      SkipIt          ; don't do bank switching if no VESA mode
        pusha
        push    es
        push    ds
        mul     cs:VesaGranularity
        mov     dx,ax
        push    dx
        xor     bx,bx           ; window A
        mov     ax,4f05h
        int     10h
        pop     dx
        mov     bx,1            ; window B
        mov     ax,4f05h
        int     10h
        pop     ds
        pop     es
        popa
SkipIt: retf}

   asm
	  db 66h; mov ax,word ptr y
	  db 66h; mov bx,VESAxres; dw 0
	  db 66h; mul bx
	  db 66h; mov bx,word ptr x
{	  db 66h; add bx,bx}
	  db 66h; add ax,bx
		  mov di,ax
                  shr ax,16

		  mov bx,VESAgranul
		  mul bx

		  mov dx,ax
                  push dx
		  xor bx,bx
		  mov ax,4f05h
 		  int 10h
        pop     dx
        mov     bx,1
        mov     ax,4f05h
        int     10h

		  mov ax,0a000h
		  mov es,ax
		  mov al,color
                  mov pom,di
		  mov [es:di],al
    end;
    Assign(F, 'vesa.out');
    Rewrite(F);
    Append(F);
    Writeln(F,pom,'-');
    Close(F);
  end;
end;

function VESAgetpixel(x,y:longint):word;
var atrib:word;
begin
if (x<VESAxres)and(y<VESAyres) then
 begin
   asm
	  db 66h; mov ax,word ptr y
	  db 66h; mov bx,VESAxres; dw 0
	  db 66h; mul bx
	  db 66h; mov bx,word ptr x
	  db 66h; add bx,bx
	  db 66h; add ax,bx
		  mov di,ax
	  db 66h; shr ax,16

		  mov bx,VESAgranul
		  mul bx

		  mov dx,ax	     {stranka}
		  mov ax,4f05h
		  xor bx,bx
		  int 10h

		  mov ax,0a000h
		  mov es,ax
		  mov ax,[es:di]
		  mov atrib,ax
    end;
     VESAgetpixel:=atrib;
  end;
end;


procedure VESAdrawline(x,y:longint; s,segm,offs:word);
var s2:word;
begin
if (y<VESAxres)and(y<VESAyres) then
begin
 if (x+s)>VESAxres then s:=VESAxres-x;
 s2:=s;
    asm 	  push ds
		  cld
	  db 66h; mov ax,word ptr y
	  db 66h; mov bx,VESAxres;dw 0
	  db 66h; mul bx
	  db 66h; mov bx,word ptr x
	  db 66h; add bx,bx
	  db 66h; add ax,bx
		  mov di,ax
	  db 66h; shr ax,16

		  mov bx,VESAgranul
		  mul bx

		  mov dx,ax	     {stranka}
		  mov ax,4f05h
		  xor bx,bx
		  int 10h

		  mov ax,0a000h
		  mov es,ax
		  mov ds,segm
		  mov si,offs

		  mov ax,di
		  add ax,s2
		  jnc @NotCrossPage	 {Pretina riadok dve stranky?}
		  shr ax,1		 {Ano}
		  mov cx,s
		  sub cx,ax
		  rep movsw		 {Cast riadku v jednej stranke}

		  mov cx,ax

		  add dx,VESAgranul 	 {stranka}
		  mov ax,4f05h
		  xor bx,bx
		  int 10h
					 {Druha cast riadku v druhej stranke}
		  rep movsw
		  jmp @EndDraw

@NotCrossPage:	  mov cx,s		 {Riadok sa nachadza v jednej sranke}
		  rep movsw

@EndDraw:
		  pop ds

     end;
  end;
end;

end.